<?php

namespace EventPortal\Domain\Util;

class Breadcrumb
{
    /**
     * @var string[]
     */
    private $breadcrumbs = [];

    public static function make(): self
    {
        return new self;
    }

    public function add(?string $label, ?string $route = null): self
    {
        $this->breadcrumbs = array_merge($this->breadcrumbs, [
            [
                'label' => $label,
                'href' => $route,
            ],
        ]);

        return $this;
    }

    public function get(): array
    {
        return $this->breadcrumbs;
    }
}
